#include <string>
#include <fstream>
#include <vector>
#include <iostream>
#include <map>
#include <math.h>
#include <random>
#include <ctime>

#include "util.cpp"

using namespace std;

class Line {
public:
    int no;
    string clean;
    string after;
    string label;
    string goto_label;
    string op1;
    string op2;
    string comparator;
    string error;
    int var_value;

    vector<string> get_words() {
        vector<string> words;
        string line = after + " ";
        string current = "";
        for (int i = 0; i < line.length(); i++)
        {
            if (line.size() >= 2 && line.substr(0, 2) == "..") {
                words.push_back("..");
                line = line.substr(2);
                i = -1;
                continue;
            }
            char c = line.at(i);
            string op_chars = "+-/<>=*^";
            size_t at_c = op_chars.find(c);
            if (at_c != string::npos) {
                int size = 1;
                char d = line.at(i + 1);
                size_t at_d = op_chars.find(d);
                if (at_d != string::npos) size++;
                string word = line.substr(0, size);
                words.push_back(word);
                line = line.substr(size + 1);
                i = -1;
                continue;
            }
            string end_chars = ")(@#$%&![]{}?;'""\\|~`\n \t.,";
            at_c = end_chars.find(c);
            if (at_c != string::npos) {
                string word = trim(line.substr(0, i));
                if (word.length() > 0)
                {
                    words.push_back(word);
                }
                line = line.substr(i + 1);
                i = -1;
                continue;
            }
        }
        return words;
    }

    int count_words() {
        vector<string> words = get_words();
        return words.size();
    }

    string last_char()
    {
        if (after.length() > 0)
            return after.substr(after.length() - 1, 1);
        else
            return "";
    }

    string first_char()
    {
        if (after.length() > 0)
            return after.substr(0, 1);
        else
            return "";
    }

    string word(int word_number) {
        return get_words().at(word_number);
    }
};
