// error was: different is <> not != and ! is not scanned as a comparator
// https://think-async.com/Asio/asio-1.22.1/doc/
// install winbuilds
// change .vscode defaults
// install wxwidgets
// setup.h is missing from wx. copy the one from msw/setup.h
// mingw32-make -f makefile.gcc MONOLITHIC=1 SHARED=1 UNICODE=1 BUILD=release
// install wxwidgetsbuilder
// create a wxwidgetsbuilder project inside the source code of a vcstudio 
// create a frame with clear and execute and a plain text editor
// save the wxwidgetsbuilder source code
// the code must have no errors before compiling


#include <string>
#include <fstream>
#include <vector>
#include <iostream>
#include <map>
#include <math.h>
#include <random>
#include <ctime>

#include "util.cpp"
#include "Line.cpp"

using namespace std;

map<string, int> var_integers;
vector<Line> lines;


int find_label(string label);

void read_lines(string filename)
{
    ifstream file(filename);
    if (!file.is_open())
    {
        return;
    }
    string text;
    int counter = 0;
    while (getline(file, text))
    {
        Line line;
        line.clean = text;
        line.after = trim(text);
        counter++;
        line.no = counter;
        lines.push_back(line);
    }
    file.close();
}


void check_line(Line& line)
{
    if (line.after.size() == 0)
    {
        return;
    }
    vector<string> words = line.get_words();
    if (words.size() == 0)
    {
        return;
    }
    if (line.first_char() == "[")
    {
        if (line.last_char() != "]")
        {
            line.error = "The print message is missing a ]";
        }
    }
    if (words.at(0) == "if")  // if a > b {end
    {
        line.goto_label = words.at(4);
        line.op1 = words.at(1);
        line.op2 = words.at(3);
        line.comparator = words.at(2);
    }
    if (words.at(0) == "jump")
    {
        if (words.size() != 2)
        {
            line.error = "jump must have a single-word target";
        }
        else
        {
            line.goto_label = words.at(1);
        }
    }
    if (line.last_char() == "}") {
        line.label = words.at(0);
    }
}

bool check_lines()
{
    bool all_ok = true;
    for (int i = 0; i < lines.size(); i++)
    {
        check_line(lines.at(i));
        if (lines.at(i).error.length() > 0)
        {
            cout << "Error in line " << lines.at(i).no << " : " << lines.at(i).clean << endl;
            cout << lines.at(i).error << endl << endl;
            all_ok = false;
        }
    }
    return all_ok;
}

int find_label(string label) {
    for (int i = 0; i < lines.size(); i++) {
        if (lines.at(i).label == label) {
            return i;
        }
    }
    return -1;
}

string replace_variables(string text) {
    for (map<string, int>::iterator i = var_integers.begin(); i != var_integers.end(); i++) {
        string var_name = "$" + i->first;
        int at = text.find(var_name);
        if (at == string::npos) continue;
        text = text.substr(0, at) + to_string(i->second) + text.substr(at + var_name.length(), text.length());
    }
    return text;
}

int evaluate(string text) {
    try {
        int result = stoi(text);
        return result;
    }
    catch (exception& e) {
        //not a number
    }
    int result = var_integers[text];
    return result;
}


bool do_comparison(string op1, string comparator, string op2)
{
    int n1 = evaluate(op1);
    int n2 = evaluate(op2);
    bool ok = do_comparison(n1, comparator, n2);
    return ok;
}

void execute_code() {
    for (int i = 0; i < lines.size(); i++) {
        Line command = lines.at(i);
        if (command.count_words() == 0) continue;
        if (command.label.length() > 0) continue;
        string text = trim(command.after);
        if (command.word(0) == "if")
        {
            bool ok = do_comparison(command.op1, command.comparator, command.op2);
            if (ok == 0)
            {
                continue;
            }
        }
        if (starts_with(text, "bored")) break;
        if (starts_with(text, "[")) {
            text = text.substr(1, text.length() - 2);
            text = replace_variables(text);
            cout << text << endl;
            continue;
        }
        if (command.goto_label.length() > 0) {
            int at = find_label(command.goto_label);
            i = at - 1;
            continue;
        }
        if (command.word(1) == "=") {
            vector<string> words = command.get_words();
            if (command.count_words() == 3) {
                words.push_back("+");
                words.push_back("0");
            }
            int op1 = evaluate(words.at(2));
            int op2 = evaluate(words.at(4));
            int resutl = evaluate(op1, words.at(3), op2);
            var_integers[command.word(0)] = resutl;
        }
        if (command.word(0) == "usi") {
            string user_text;
            cin >> user_text;
            int user_no = evaluate(user_text);
            var_integers[command.word(1)] = user_no;
        }
    }
}

int main2(int argc, char** argv)
{
    Line l;
    l.after = "if a > b {end";
    vector<string> words = l.get_words();
    cout << "Words found=" << l.count_words() << endl;
    for (int i = 0; i < words.size(); i++)
    {
        cout << words.at(i) << endl;
    }
    return 0;
}


int main(int argc, char** argv)
{
    srand((unsigned)time(NULL));
    rand();

    string filename = "first.spn";
    if (argc > 1) filename = argv[1];
    cout << "Running " << filename << endl;
    read_lines(filename);
    bool ok = check_lines();
    if (ok) {
        execute_code();
    }
    else {
        cout << "Parsing found errors - terminating..." << endl;
    }

    return 0;
}
