#ifndef UTIL_CPP
#define UTIL_CPP

#include <string>
#include <fstream>
#include <vector>
#include <iostream>
#include <map>
#include <math.h>
#include <random>
#include <ctime>

using namespace std;

int random2(int _min, int _max)  // for DIMITRIS
{    
    int rnd = (int)(rand()/(double)RAND_MAX * (_max - _min + 1)) + _min;
    return rnd;
}

int random(int num1, int num2) {   // for GIANNIS and THOMAS
    std::random_device dev;
    std::mt19937 rng(dev());
    std::uniform_int_distribution<std::mt19937::result_type> dist(num1, num2); // distribution in range [1, 6]

    return dist(rng);
}

string trim_right(string line)
{
    string new_line = "";
    for (int i = line.length() - 1; i >= 0; i--)
    {
        if (line.at(i) != ' ')
        {
            new_line = line.substr(0, i + 1);
            break;
        }
    }
    return new_line;
}

string trim_left(string line)
{
    string new_line;
    bool copy = false;
    for (int i = 0; i < line.length(); i++)
    {
        if (line.at(i) != ' ')
        {
            copy = true;
        }
        if (copy)
        {
            new_line = new_line + line.at(i);
        }
    }
    return new_line;
}

string trim(string line)
{
    return trim_left(trim_right(line));
}

bool starts_with(string text, string search)
{
    return text.find(search) == 0;
}

int search_for(string text, char c)
{
    int found = 0;
    for (int i = 0; i < text.length() - 1; i++)
    {
        if (text.at(i) == c)
        {
            found++;
        }
    }
    return found;
}

//Overloading
int evaluate(int op1, string operation, int op2) {
    if (operation == "+") return op1 + op2;
    if (operation == "-") return op1 - op2;
    if (operation == "*") return op1 * op2;
    if (operation == "/") return op1 / op2;
    if (operation == "^") return pow(op1, op2);
    if (operation == "..") return random2(op1, op2);
    return 0;
}


bool do_comparison(int n1, string comparator, int n2)
{
    if (comparator == "==") return n1 == n2;
    if (comparator == ">=") return n1 >= n2;
    if (comparator == "!=") return n1 != n2;
    if (comparator == "<>") return n1 != n2;
    if (comparator == "<=") return n1 <= n2;
    if (comparator == ">") return n1 > n2;
    if (comparator == "<") return n1 < n2;
    return false;
}


#endif